/*
* March 2001, Junichi Morita
*  this fnkeyd is the launcher.
*  get the key event from "sonypi.o" module and lauch an application.
*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>

#include "../sonypi/sonypi.h"

#define  VERSION	"0.1"

#define  CONFFILE	"/etc/fnkeyd.conf"
#define  DEVICE		"/dev/spic_fnkey"

static char esc[256];
static char fnkey[12][256];
static int fd;

void handl_chld(int sig)
{
 printf("signal\n");
}

int get_config()
{
FILE *cfd;
char buf[256];
int i,ifn,ilen,ist,icst;

	cfd=fopen(CONFFILE,"r");
	if( !cfd ) return(1);
	while( fgets(buf,sizeof(buf),cfd) ){
		ilen=strlen(buf);
		if( buf[ilen-1]<0x20 ) ilen--;buf[ilen]=0x0;
		for(i=0,ist=0;i<ilen;i++){
			if(buf[i]>0x20){
				ist=i;
				break;
			}
		}
		if( buf[ist]=='#' ) continue;
		for(i=0,icst=0;i<ilen;i++){
			if(buf[i]==':'){
				icst=i+1;
				break;
			}
		}
		if( !strncmp(&buf[ist],"ESC:",4) ){
			strcpy(esc,&buf[ist+4]);
//			printf("ESC:<%s>\n",esc);
		}else if( buf[ist]=='F' ){
			sscanf(&buf[ist],"F%d:",&ifn);
			strcpy(fnkey[ifn-1],&buf[icst]);
//			printf("<%d><%s>\n",ifn,fnkey[ifn-1]);
		}else{
			printf("unknown config [%s]",buf);
		}
	}
	return 0;
}

int do_launch(char *cmd)
{
pid_t pid;
int i,iarg,ist;
char args[32][128],*argp[32];

	if( !(pid=fork()) ){
		iarg=ist=0;
		for(i=0;i<strlen(cmd)&&iarg<31;i++){
			if( cmd[i]==0x20 ){
				memset(args[iarg],0,128);
				strncpy(args[iarg],&cmd[ist],i-ist);
				argp[iarg]=args[iarg];
				iarg++;
				ist=i+1;
			}
		}
		if( iarg<31 ){
			memset(args[iarg],0,128);
			strncpy(args[iarg],&cmd[ist],i-ist);
			argp[iarg]=args[iarg];
		}
		argp[iarg+1]=NULL;
		close(0);
		close(1);
		close(2);
		close(fd);
		execvp(args[0],argp);
		exit(0);
	}
 printf("fork %d\n",pid);
	return (int)pid;
}

int main(argc,argv)
int argc;
char **argv;
{
int size,i,key;
char buf[8];

	memset(esc,0,sizeof(esc));
	for(i=0;i<12;i++) memset(fnkey[i],0,256);
	if( get_config() ){
		printf( "Can't open config file [%s]\n",CONFFILE );
		exit(1);
	}
	fd = open( DEVICE,O_RDONLY);
	if( fd==0 ){
		printf( "Device file can't open [%s]\n",DEVICE );
		exit(1);
	}
	signal(SIGCHLD,handl_chld);
	while( 1 ){
		buf[0]=buf[1]=0x0;
		size=read( fd,buf,sizeof(buf) );
		if( !size ) continue;
		if( size==1 ){
			key=(unsigned int)buf[0];
		}else{
			sscanf(buf,"F%x",&key);
		}
//		printf("%d<0x%x>\n",size,key);
		switch( key ){
			case SPIC_FNKEY_ESC:
				if( esc ) do_launch(esc);
				break;
			case SPIC_FNKEY_F1:
			case SPIC_FNKEY_F2:
			case SPIC_FNKEY_F3:
			case SPIC_FNKEY_F4:
			case SPIC_FNKEY_F5:
			case SPIC_FNKEY_F6:
			case SPIC_FNKEY_F7:
			case SPIC_FNKEY_F8:
			case SPIC_FNKEY_F9:
			case SPIC_FNKEY_F10:
			case SPIC_FNKEY_F11:
			case SPIC_FNKEY_F12:
				i=key-SPIC_FNKEY_F1;
				if( fnkey[i][0] ) do_launch(fnkey[i]);
				break;
		}
	}
	close(fd);
}
